/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h> 
#include <errno.h>
#include <sys/time.h>
#include <ctype.h>

#include "engine.h"
#include "cgi.h"
#include "libwap.h"

#define KEYSTR "<input type=\"hidden\" value=\""


static void wap_info(char *p)
{
	wml_header(-1);
	printf("<card>");
	wml_back();
	printf("<p>%s</p></card>\n",p);
	wml_footer();
	exit(0);
}

static char * encode_string(char *buf)
{
	static char m[512];
	char *mp=m;
	
	while(*buf)
	{
		if(*buf==' ')
		{
			*mp++='+';
			buf++;
			continue;
		}
		if(!isalnum(*buf))
		{
			*mp++='%';
			sprintf(mp, "%02X", *buf);
			buf++;
			mp+=2;
			continue;
		}
		*mp++=*buf++;
	}
	*mp=0;
	return m;
}

static void post_message(int num, char *phone, char *msg)
{
	int s;
	char buf[512];
	char *tp;
	
	
	sprintf(buf, "/uk/cgi-bin/sms/send_uk_sms4.cgi?msgnr=%d&ren=%s&msg=%s&Len=%d&SUBMIT.x=0&SUBMIT.y=0&prg=1",
		num, phone, encode_string(msg), strlen(msg));
		
	s=host_connect("smscgi04-1.lycos.de", 80);
	if(s==-1)
		exit(1);
	host_get_ref(s, "smscgi04-1.lycos.de", buf, "http://www.lycos.co.uk/service/sms/eingabe.html");

	while((tp=host_readline(s))!=NULL)
	{
		if(strstr(tp, "danke"))
			wap_info("OK - lycos.co.uk delivering SMS.\n");
	}	
	close(s);
	wap_info("lycos.co.uk - no ok.\n");
}

int main(int argc, char *argv[])
{
	int s;
	char *tp, *to, *body;

	printf("Content-Type: text/vnd.wap.wml\r\n");
	printf("Cache-Control: max-age=0\r\n");
	printf("\r\n");	
			
	cgi_process();
	to=cgi_find("to");
			
	if(to==NULL)
		wap_info("No sender ?");
		
	body=cgi_find("body");
	if(body==NULL)
		wap_info("No message ?");
	
	tp=to;
	while(*tp)
	{
		if(!isdigit(*tp))
			wap_info("phone number must be numeric");
		tp++;
	}
	if(strncmp(to, "00", 2)==0)
		wap_info("Only UK numbers supported");

	if(strlen(body)>130)
		wap_info("message too long");
	
	s=host_connect("www.lycos.co.uk", 80);
	if(s==-1)
		exit(1);
	host_get(s, "www.lycos.co.uk", "/service/sms/eingabe.html");
	while((tp=host_readline(s))!=NULL)
	{
		int n;
		if(strncmp(tp, KEYSTR,strlen(KEYSTR)))
			continue;
		if(sscanf(tp+strlen(KEYSTR), "%d", &n)!=1)
			continue;
//		printf("Message ID %d\n", n);
		close(s);
		post_message(n, to, body);
		exit(0);
	}
	wap_info("unable to get a message id");
	exit(1);
}
